---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: include/TGUI/Loading/Theme.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_380f920385a16f176be7632160138052.html">TGUI</a></li><li class="navelem"><a class="el" href="dir_740ee9f1b9706f31d0e73157e21ad61d.html">Loading</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Theme.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// TGUI - Texus&#39;s Graphical User Interface</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Copyright (C) 2012-2017 Bruno Van de Velde (vdv_b@tgui.eu)</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// This software is provided &#39;as-is&#39;, without any express or implied warranty.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// In no event will the authors be held liable for any damages arising from the use of this software.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// Permission is granted to anyone to use this software for any purpose,</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// including commercial applications, and to alter it and redistribute it freely,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// subject to the following restrictions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// 1. The origin of this software must not be misrepresented;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//    you must not claim that you wrote the original software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//    If you use this software in a product, an acknowledgment</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//    in the product documentation would be appreciated but is not required.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// 2. Altered source versions must be plainly marked as such,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//    and must not be misrepresented as being the original software.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// 3. This notice may not be removed or altered from any source distribution.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef TGUI_THEME_HPP</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define TGUI_THEME_HPP</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;TGUI/Widget.hpp&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;TGUI/Loading/WidgetConverter.hpp&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;TGUI/Loading/ThemeLoader.hpp&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacetgui.html">tgui</a></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;{</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classtgui_1_1BaseTheme.html">   42</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1BaseTheme.html">BaseTheme</a> : <span class="keyword">public</span> std::enable_shared_from_this&lt;BaseTheme&gt;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="classtgui_1_1BaseTheme.html">BaseTheme</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> widgetAttached(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> widgetDetached(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a> internalLoad(<span class="keyword">const</span> std::string&amp; primary, <span class="keyword">const</span> std::string&amp; secondary) = 0;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> initWidget(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget, std::string primary, std::string secondary) = 0;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> setConstructFunction(<span class="keyword">const</span> std::string&amp; type, <span class="keyword">const</span> std::function&lt;<a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>()&gt;&amp; constructor);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> setThemeLoader(<span class="keyword">const</span> std::shared_ptr&lt;BaseThemeLoader&gt;&amp; themeLoader);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="comment">// Calls the protected widget-&gt;reload(primary, secondary, force) function</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> widgetReload(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget, <span class="keyword">const</span> std::string&amp; primary = <span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> std::string&amp; secondary = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">bool</span> force = <span class="keyword">false</span>);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="classtgui_1_1BaseTheme.html#a11159db7392530214ecc982e9b0f55b8">  122</a></span>&#160;        <span class="keyword">static</span> std::map&lt;std::string, std::function&lt;Widget::Ptr()&gt;&gt; <a class="code" href="classtgui_1_1BaseTheme.html#a11159db7392530214ecc982e9b0f55b8">m_constructors</a>; </div><div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="classtgui_1_1BaseTheme.html#a5d1445eda90da9bf03a9c433df10d6b6">  123</a></span>&#160;        <span class="keyword">static</span> std::shared_ptr&lt;BaseThemeLoader&gt; <a class="code" href="classtgui_1_1BaseTheme.html#a5d1445eda90da9bf03a9c433df10d6b6">m_themeLoader</a>;  </div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    };</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno"><a class="line" href="classtgui_1_1Theme.html">  131</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1Theme.html">Theme</a> : <span class="keyword">public</span> <a class="code" href="classtgui_1_1BaseTheme.html">BaseTheme</a></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    {</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="classtgui_1_1Theme.html#a6428ad1bf9c7b651f42e4863a91b82bf">  135</a></span>&#160;        <span class="keyword">typedef</span> std::shared_ptr&lt;Theme&gt; <a class="code" href="classtgui_1_1Theme.html#a6428ad1bf9c7b651f42e4863a91b82bf">Ptr</a>; </div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <a class="code" href="classtgui_1_1Theme.html">Theme</a>(<span class="keyword">const</span> std::string&amp; filename = <span class="stringliteral">&quot;&quot;</span>);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keyword">static</span> <a class="code" href="classtgui_1_1Theme.html#a6428ad1bf9c7b651f42e4863a91b82bf">Theme::Ptr</a> create(<span class="keyword">const</span> std::string&amp; filename = <span class="stringliteral">&quot;&quot;</span>);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <a class="code" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a> load(std::string className);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordtype">void</span> reload(<span class="keyword">const</span> std::string&amp; filename);</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keywordtype">void</span> reload(std::string oldClassName, std::string newClassName);</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keywordtype">void</span> reload(<a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> widget, std::string className);</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keywordtype">void</span> setProperty(std::string className, <span class="keyword">const</span> std::string&amp; property, <span class="keyword">const</span> std::string&amp; value);</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <span class="keywordtype">void</span> setProperty(std::string className, <span class="keyword">const</span> std::string&amp; property, <a class="code" href="classtgui_1_1ObjectConverter.html">ObjectConverter</a>&amp;&amp; value);</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        std::string getProperty(std::string className, std::string property) <span class="keyword">const</span>;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        std::map&lt;std::string, std::string&gt; getPropertyValuePairs(std::string className) <span class="keyword">const</span>;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        std::shared_ptr&lt;Theme&gt; clone() <span class="keyword">const</span>;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> widgetDetached(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget) <span class="keyword">override</span>;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a> internalLoad(<span class="keyword">const</span> std::string&amp; filename, <span class="keyword">const</span> std::string&amp; className) <span class="keyword">override</span>;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> initWidget(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget, std::string filename, std::string className) <span class="keyword">override</span>;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        std::string m_filename;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        std::string m_resourcePath;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        <span class="keywordtype">bool</span> m_resourcePathLock = <span class="keyword">false</span>;</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        std::map&lt;Widget*, std::string&gt; m_widgets; <span class="comment">// Map widget to class name</span></div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        std::map&lt;std::string, std::string&gt; m_widgetTypes; <span class="comment">// Map class name to type</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        std::map&lt;std::string, std::map&lt;std::string, std::string&gt;&gt; m_widgetProperties; <span class="comment">// Map class name to property-value pairs</span></div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span>ThemeTest;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    };</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;}</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;<span class="preprocessor">#endif // TGUI_THEME_HPP</span></div><div class="ttc" id="namespacetgui_html"><div class="ttname"><a href="namespacetgui.html">tgui</a></div><div class="ttdoc">Namespace that contains all TGUI functions and classes. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:33</div></div>
<div class="ttc" id="classtgui_1_1BaseTheme_html_a11159db7392530214ecc982e9b0f55b8"><div class="ttname"><a href="classtgui_1_1BaseTheme.html#a11159db7392530214ecc982e9b0f55b8">tgui::BaseTheme::m_constructors</a></div><div class="ttdeci">static std::map&lt; std::string, std::function&lt; Widget::Ptr()&gt; &gt; m_constructors</div><div class="ttdoc">Widget creator functions. </div><div class="ttdef"><b>Definition:</b> Theme.hpp:122</div></div>
<div class="ttc" id="classtgui_1_1Widget_html"><div class="ttname"><a href="classtgui_1_1Widget.html">tgui::Widget</a></div><div class="ttdoc">The parent class for every widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:71</div></div>
<div class="ttc" id="classtgui_1_1Theme_html_a6428ad1bf9c7b651f42e4863a91b82bf"><div class="ttname"><a href="classtgui_1_1Theme.html#a6428ad1bf9c7b651f42e4863a91b82bf">tgui::Theme::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; Theme &gt; Ptr</div><div class="ttdoc">Shared theme pointer. </div><div class="ttdef"><b>Definition:</b> Theme.hpp:135</div></div>
<div class="ttc" id="classtgui_1_1Theme_html"><div class="ttname"><a href="classtgui_1_1Theme.html">tgui::Theme</a></div><div class="ttdoc">Default Theme class. </div><div class="ttdef"><b>Definition:</b> Theme.hpp:131</div></div>
<div class="ttc" id="classtgui_1_1ObjectConverter_html"><div class="ttname"><a href="classtgui_1_1ObjectConverter.html">tgui::ObjectConverter</a></div><div class="ttdoc">Implicit converter for settable properties. </div><div class="ttdef"><b>Definition:</b> ObjectConverter.hpp:42</div></div>
<div class="ttc" id="classtgui_1_1WidgetConverter_html"><div class="ttname"><a href="classtgui_1_1WidgetConverter.html">tgui::WidgetConverter</a></div><div class="ttdoc">Implicit converter for widgets returned by the load function of the theme. </div><div class="ttdef"><b>Definition:</b> WidgetConverter.hpp:40</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a388912f13898735531886bc676b14f81"><div class="ttname"><a href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">tgui::Widget::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; Widget &gt; Ptr</div><div class="ttdoc">Shared widget pointer. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:75</div></div>
<div class="ttc" id="classtgui_1_1BaseTheme_html"><div class="ttname"><a href="classtgui_1_1BaseTheme.html">tgui::BaseTheme</a></div><div class="ttdoc">Base class for the Theme classes. </div><div class="ttdef"><b>Definition:</b> Theme.hpp:42</div></div>
<div class="ttc" id="classtgui_1_1BaseTheme_html_a5d1445eda90da9bf03a9c433df10d6b6"><div class="ttname"><a href="classtgui_1_1BaseTheme.html#a5d1445eda90da9bf03a9c433df10d6b6">tgui::BaseTheme::m_themeLoader</a></div><div class="ttdeci">static std::shared_ptr&lt; BaseThemeLoader &gt; m_themeLoader</div><div class="ttdoc">Theme loading functions, they read the theme file. </div><div class="ttdef"><b>Definition:</b> Theme.hpp:123</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:40 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
